--- speex-1.1.11.1/libspeex/cb_search.c	2005-11-20 10:27:08.000000000 +0100
+++ speex/libspeex/cb_search.c	2005-12-08 22:06:44.000000000 +0100
@@ -50,16 +50,14 @@
 #ifndef OVERRIDE_COMPUTE_WEIGHTED_CODEBOOK
 static void compute_weighted_codebook(const signed char *shape_cb, const spx_word16_t *r, spx_word16_t *resp, spx_word16_t *resp2, spx_word32_t *E, int shape_cb_size, int subvect_size, char *stack)
 {
-   int i, j, k;
-   VARDECL(spx_word16_t *shape);
-   ALLOC(shape, subvect_size, spx_word16_t);
+   int i, j, k, sbv_size;
+
    for (i=0;i<shape_cb_size;i++)
    {
       spx_word16_t *res;
-      
-      res = resp+i*subvect_size;
-      for (k=0;k<subvect_size;k++)
-         shape[k] = (spx_word16_t)shape_cb[i*subvect_size+k];
+      sbv_size = i*subvect_size;
+
+      res = resp+sbv_size;
       E[i]=0;
 
       /* Compute codeword response using convolution with impulse response */
@@ -67,8 +65,9 @@
       {
          spx_word32_t resj=0;
          spx_word16_t res16;
+
          for (k=0;k<=j;k++)
-            resj = MAC16_16(resj,shape[k],r[j-k]);
+            resj = MAC16_16(resj,(spx_word16_t)shape_cb[sbv_size+k],r[j-k]);
 #ifdef FIXED_POINT
          res16 = EXTRACT16(SHR32(resj, 11));
 #else


